<template>
  <section>
    <el-table
      :data="items" >
      <el-table-column
        prop="id"
        label="ID"
        width="30"
        >
      </el-table-column>
      <el-table-column
        prop="project"
        label="Project"
      >
          <template slot-scope="scope">
            <label>{{getProject(scope.row.project)}} </label>
          </template>
      </el-table-column>
      <el-table-column 
        label="User"
        >
          <template slot-scope="scope">
            <label>{{getUser(scope.row.user)}}</label>
          </template>
      </el-table-column>
      <el-table-column
        prop="startat"
        label="Start at"
        width="120"
        >
      </el-table-column>
      <el-table-column
        prop="endat"
        label="End at"
        width="120"
        >
      </el-table-column>
      <el-table-column
        prop="timeot"
        label="Time ot"
            width="70"
        >
      </el-table-column>
      <el-table-column
        label="Status"
        width="90"
        >
         <template slot-scope="scope">
            <el-tag :type="scope.row.status==0?'infor':scope.row.status==1?'success':'warning'">{{scope.row.status==0? 'Request':scope.row.status==1?'Approve':'Reject'}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column 
        prop="reason"
        label="Reason"
        >
      </el-table-column>
        <el-table-column label="Approve" width="82">
           <template slot-scope="scope">
              <el-button :disabled="scope.row.status==1" size="small" type="success" @click="changeStatus(scope.row.id,1)">Approve</el-button>
          </template>
        </el-table-column>
        <el-table-column label="Reject" width="72">
           <template slot-scope="scope">
              <el-button :disabled="scope.row.status==2" size="small" type="warning"  @click="changeStatus(scope.row.id,2)" >Reject</el-button>
          </template>
        </el-table-column>
        <el-table-column label="Edit" width="73">
           <template slot-scope="scope">
              <el-button size="small" type="primary" @click="editRow(scope.row.id)"><i class="el-icon-edit"></i> Edit</el-button>
          </template>
        </el-table-column>
        <el-table-column label="Delete" width="88">
          <template slot-scope="scope">
              <el-button size="small" type="danger" @click="deleteRow(scope.row.id)"><i class="el-icon-delete"></i> Delete</el-button>
          </template> 
      </el-table-column>    
    </el-table>
  </section>
</template>

<script>

import callApi from './../middleware/apiCaller.js'

var dateFormat = require('dateformat');

  export default {
    data() {
      return {
          tasks:[],
          taskId:'',
          taskUser:[],
          taskProject:[],
          project:'',
          user:'',
          status:'',
          startat:'',
          endat:'',
          timeot:'',
          reason:'',
          comment:'',
      }
    },

    props:['items'],

    mounted() {

      // call API from server
      callApi('user','GET').then(res =>{
        this.taskUser=res.data
      })  

      // call API from server
      callApi('project','GET').then(res =>{
        this.taskProject=res.data
      })

    },

    methods: {

      //property setData use to set data input
      setData(status){
        return{

          project:this.project,
          user:this.user,
          startat:this.startat,
          endat:this.endat,
          timeot:this.timeot,
          reason:this.reason,
          comment:this.comment,
          status:status,
          
        }
      },

      // function c
      changeStatus(id,status){

       callApi('overtime/'+id, 'GET',null).then(res =>{

          this.taskId=res.data,
          this.project=this.taskId.project,
          this.user=this.taskId.user,
          this.startat=this.taskId.startat,
          this.endat=this.taskId.endat,
          this.timeot=this.taskId.timeot,
          this.reason=this.taskId.reason,
          this.comment=this.taskId.comment

          if(status==1){
            callApi('overtime/'+id,'PUT',this.setData(status)).then(res =>{
              this.$message({
                type:"success",
                message: "Approve completed"
              }),
              this.$emit('search')
            }
            )
          }
          else
          {
            callApi('overtime/'+id,'PUT',this.setData(status)).then(res =>{
              this.$message({
                  type:"warning",
                  message: "Reject completed"
              }),
              this.$emit('search')
            })
          }
       })
      },

      // hàm lấy tên user
      getUser(params){

        for(let i = 0; i < this.taskUser.length; i++){
          if(this.taskUser[i].id===params){
            return this.taskUser[i].name
          }
        }
      },
      //hàm lấy tên project
      getProject(params){

        for( let i=0; i<this.taskProject.length; i++){
          if(this.taskProject[i].id===params){
            return this.taskProject[i].project
          }
        }
      },

      // hàm edit
      editRow(params){
        this.$router.push({ name: 'overtime-edit',query:{id:params}})
      },

      // hàm delete
      deleteRow(params){

         this.$confirm('This will permanently delete the file. Continue?', 'Warning', {
          confirmButtonText: 'OK',
          cancelButtonText: 'Cancel',
          type: 'warning'
        }).then(() => {

          callApi('overtime/'+params, 'DELETE', null).then(res =>{
            this.$message({
            type: 'success',
            message: 'Delete completed'
          });
          this.$emit('reloadData')
          })
        }).catch(() => {
          this.$message({
            type: 'info',
            message: 'Delete canceled'
          });          
        });
      },
      
    },
  }
</script>